#ifndef _U8_FUNCTIONS_H_
#define _U8_FUNCTIONS_H_

/*
 * u8_functions.h
 * 
 * Musterloesung zu Uebung 8, Informatik I, D-ITET, WS 03/04
 *
 * Edouard Lamboray, 17.12.2002
 */

// The struct used for storing a (date, temperature) tuple.
struct Temperature {
  unsigned short day;
  unsigned short month;
  unsigned short year;
  float temperature;  
};


// Returns the number of data items of the predefined format for
// (date, temperature) values in a file.
// Returns -1 on error.
int numberOfItems(const char *filename);

// Reads the data items of the predefined format for (date, temperature) from
// a file into the array of Temperature structs.
// The Temperature array must be allocated and must be of sufficient size.
// Returns the number of correctly read data items.
// Returns -1 on error.
int readTemperatures(const char *filename, Temperature *t, int size);

// Writes the data items from an array of Temperature structs into a file 
// using the predefined format for (date, temperature).
// if t==0, the temperatures are randomly generated.
// Returns the number of correctly written data items.
// Returns -1 on error.
// <This function was not part of the assignment.>
int writeTemperatures(const char *filename, Temperature *t, int size);

// Writes the data items from an array of Temperature structs into a text file.
// The last line in the text file contains the average temperature of the data
// set. 
// Returns the number of correctly written data items.
// Returns -1 on error.
int writeTemperaturesAsText(const char *filename, Temperature *t, 
                            int size, float average);

// Computes the average temperature of a data set.
float computeAverage(Temperature *t, int size);

#endif
