/*
 * u8_main.h
 * 
 * Musterloesung zu Uebung 8, Informatik I, D-ITET, WS 03/04
 *
 * Edouard Lamboray, 17.12.2002
 */

#include "u8_functions.h"
#include <iostream>
#include <cstring>

using namespace std;

int main(int argc, char **argv)
{
  if(argc < 3) {
    cout << "Usage: input_file output_file -g\n\t-g: generates a random temperature file called <input_file>\n";
    return 0;
  }

  if(argc==4) {
    if(!strcmp("-g", argv[3])) {
      // generate random temperatures
      writeTemperatures(argv[1], 0, 31);
    }
  }

  // Check the number of elements
  const int nbItems = numberOfItems(argv[1]);
  if(nbItems < 1) {
    cout << "No data items found in " << argv[1] << endl;
    return 0;
  }
  cout << "We expect " << nbItems << " temperature values from " << argv[1] << endl;

  // Memory allocation
  Temperature *temperatures = new Temperature[nbItems];

  // Read the data
  if(nbItems != readTemperatures(argv[1], temperatures, nbItems)) {
    cout << "Error while reading data from " << argv[1] << endl;
  }
  
  // Average computation
  const float average = computeAverage(temperatures, nbItems);

  // Store temperatures in text file
  if(nbItems != writeTemperaturesAsText(argv[2], temperatures, nbItems, average)) {
    cout << "Error while writing data to " << argv[2] << endl;
  }
  else {
    cout << argv[2] << " has been successfully written.\n";
  }

  // Memory deallocation
  delete [] temperatures;

  return 0;     
}
